//
//  rssAppDelegate.m
//  rss
//
//  Created by kunii on 09/09/13.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "rssAppDelegate.h"
#import "RootViewController.h"

@interface rssAppDelegate (private)	//	libxmlからの呼び出し用メソッド定義
- (void)startElementLocalName:(const xmlChar*)localname 
        prefix:(const xmlChar*)prefix 
        URI:(const xmlChar*)URI 
        nb_namespaces:(int)nb_namespaces 
        namespaces:(const xmlChar**)namespaces 
        nb_attributes:(int)nb_attributes 
        nb_defaulted:(int)nb_defaulted 
        attributes:(const xmlChar**)attributes;
- (void)endElementLocalName:(const xmlChar*)localname 
        prefix:(const xmlChar*)prefix URI:(const xmlChar*)URI;
- (void)charactersFound:(const xmlChar*)ch 
        len:(int)len;
@end

/*
	新しいタグが見つかった。
*/
static void startElementHandler(
        void* ctx, 
        const xmlChar* localname, 
        const xmlChar* prefix, 
        const xmlChar* URI, 
        int nb_namespaces, 
        const xmlChar** namespaces, 
        int nb_attributes, 
        int nb_defaulted, 
        const xmlChar** attributes)
{
	//	rssAppDelegateのメソッドにそのまま渡す。
    [(rssAppDelegate*)ctx 
            startElementLocalName:localname 
            prefix:prefix URI:URI 
            nb_namespaces:nb_namespaces 
            namespaces:namespaces 
            nb_attributes:nb_attributes 
            nb_defaulted:nb_defaulted 
            attributes:attributes];
}

/*
	見つかったタグが閉じた。
*/
static void	endElementHandler(
        void* ctx, 
        const xmlChar* localname, 
        const xmlChar* prefix, 
        const xmlChar* URI)
{
	//	rssAppDelegateのメソッドにそのまま渡す。
    [(rssAppDelegate*)ctx 
            endElementLocalName:localname 
            prefix:prefix 
            URI:URI];
}

/*
	現在のタグの文字列データが見つかった。
*/
static void	charactersFoundHandler(
        void* ctx, 
        const xmlChar* ch, 
        int len)
{
	//	rssAppDelegateのメソッドにそのまま渡す。
    [(rssAppDelegate*)ctx 
            charactersFound:ch len:len];
}

static xmlSAXHandler _saxHandlerStruct = {
    NULL,            /* internalSubset */
    NULL,            /* isStandalone   */
    NULL,            /* hasInternalSubset */
    NULL,            /* hasExternalSubset */
    NULL,            /* resolveEntity */
    NULL,            /* getEntity */
    NULL,            /* entityDecl */
    NULL,            /* notationDecl */
    NULL,            /* attributeDecl */
    NULL,            /* elementDecl */
    NULL,            /* unparsedEntityDecl */
    NULL,            /* setDocumentLocator */
    NULL,            /* startDocument */
    NULL,            /* endDocument */
    NULL,            /* startElement*/
    NULL,            /* endElement */
    NULL,            /* reference */
    charactersFoundHandler, /* characters */
    NULL,            /* ignorableWhitespace */
    NULL,            /* processingInstruction */
    NULL,            /* comment */
    NULL,            /* warning */
    NULL,            /* error */
    NULL,            /* fatalError //: unused error() get all the errors */
    NULL,            /* getParameterEntity */
    NULL,            /* cdataBlock */
    NULL,            /* externalSubset */
    XML_SAX2_MAGIC,  /* initialized */		//	SAXで扱うにはこの値を設定するみたい。
    NULL,            /* private */
    startElementHandler,    /* startElementNs */
    endElementHandler,      /* endElementNs */
    NULL,            /* serror */
};

@implementation rssAppDelegate

@synthesize window;
@synthesize navigationController;

#pragma mark -
#pragma mark Application lifecycle

- (void)applicationDidFinishLaunching:(UIApplication *)application {    
    
    // Override point for customization after app launch    
	
	[window addSubview:[navigationController view]];
    [window makeKeyAndVisible];

	htmlstring =[[NSMutableData alloc] init];

	// XMLパーサを作成する
	_parserContext = xmlCreatePushParserCtxt(&_saxHandlerStruct, self, NULL, 0, NULL);
	bbs = [[NSMutableArray alloc] init];		//	BBSデータ保持用インスタンス作成
#define USE_GET_METHOD 0	//	GETを試す時は 1 にする。
#if USE_GET_METHOD		//	GETを使う場合
	// URLを指定する
	NSURLRequest* request = [NSURLRequest requestWithURL:[NSURL URLWithString:@"http://localhost/test.php?name=test+data&location=osaka%2Cjapan"]];
#else					//	POSTを使う場合
	// URLを指定する
	NSMutableURLRequest* request = [[[NSMutableURLRequest alloc] init] autorelease];
	[request setURL:[NSURL URLWithString:@"http://localhost/bbs.php"]];
	[request setHTTPMethod:@"POST"];
	#define USEX_WWW_FORM_URLENCODED 0	//	application/x-www-form-urlencoded指定を使うなら 1
	#if USEX_WWW_FORM_URLENCODED	
		[request addValue:@"application/x-www-form-urlencoded" forHTTPHeaderField: @"Content-Type"];
		//	内容部作成
		NSMutableData *body = [NSMutableData data];
		[body appendData:[[NSString stringWithFormat:@"name=test+data&location=osaka%%2Cjapan"] dataUsingEncoding:NSUTF8StringEncoding]];
	#else	//	multipart/form-dataを使う
		NSString *boundary = [NSString stringWithString:@"xcc2009"];	//	境界文字列
		NSString *contentType = [NSString stringWithFormat:@"multipart/form-data; boundary=%@",boundary];
		[request addValue:contentType forHTTPHeaderField: @"Content-Type"];
		//	内容部作成
		NSMutableData *body = [NSMutableData data];
		//	name=test dataの設定
		[body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithString:@"Content-Disposition: form-data; name=\"name\"\r\n"] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithString:@"Content-Type: text/plain;charset=utf8\r\n\r\n"] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithString:@"test data"] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithFormat:@"\r\n--%@--\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
		//	location=osaka,japanの設定
		[body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithString:@"Content-Disposition: form-data; name=\"location\"\r\n"] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithString:@"Content-Type: text/plain;charset=utf8\r\n\r\n"] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithString:@"osaka,japan"] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithFormat:@"\r\n--%@--\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
	#endif
	//	内容物追加
	[request setHTTPBody:body];
#endif
	// URLコネクションを作る
	[NSURLConnection connectionWithRequest:request delegate:self];
}

enum {
	keyword_Unknown = -1,
	keyword_Name,
	keyword_Date,
	keyword_Comment
};

const NSString* keywords[] = {
	@"name",
	@"date",
	@"comment"
};

- (void)connectionDidFinishLoading:(NSURLConnection*)connection
{
	// データが終わった事を伝える。
    xmlParseChunk(_parserContext, NULL, 0, 1);
    // XMLパーサを解放する
	xmlFreeParserCtxt(_parserContext);
	
	//	HTMLをそのままUIWebViewでレンダリング。
	UIWebView* webView = (UIWebView*)[(UIView*)[(UITableView*)[self.window viewWithTag:TABLE_VIEW_TAG] cellForRowAtIndexPath:[NSIndexPath indexPathForRow:0 inSection:0]] viewWithTag:WEB_VIEW_TAG];
	NSString* str = [[NSString alloc] initWithData:htmlstring encoding:NSUTF8StringEncoding];
	[webView loadHTMLString:str baseURL:[NSURL URLWithString:@"http://localhost/bbs.php"]];
	//	コンソールへの出力
	printf([str UTF8String]);			
	[str release];

	//	取り出したbbsデータをコンソールに表示。
	int c = [bbs count];
	printf("\n---------------------\n", c);
	printf("bbs item counts = %d\n", c);
	printf("---------------------\n", c);
	for (int i = 0; i < c; i++) {
		NSMutableDictionary* item = [bbs objectAtIndex:i];
		printf("name = %s\n", [[item objectForKey:keywords[keyword_Name]] UTF8String]);
		printf("date = %s\n", [[item objectForKey:keywords[keyword_Date]] UTF8String]);
		printf("comment = %s\n", [[item objectForKey:keywords[keyword_Comment]] UTF8String]);
	}
}

- (void)connection:(NSURLConnection*)connection
        didReceiveData:(NSData*)data
{	
    // データを追加する
    xmlParseChunk(_parserContext, (const char*)[data bytes], [data length], 0);
	//	dataをhtmlstring側に保存していく。
	[htmlstring appendData:data];
}

- (void)applicationWillTerminate:(UIApplication *)application {
	// Save data if appropriate
}


#pragma mark -
#pragma mark Memory management

- (void)dealloc {
	[navigationController release];
	[window release];
	[htmlstring release];
	[bbs release];
	[super dealloc];
}

/*
	xmlの一要素にぶつかった時に呼び出される。
	<html>	←1
	<head>	←2
		<title>掲示板</title>	←3
	</head>
*/
- (void)startElementLocalName:(const xmlChar*)localname		//	HTMLのタグが<>を外された形で入っている。例）<form> → form
        prefix:(const xmlChar*)prefix 
        URI:(const xmlChar*)URI 
        nb_namespaces:(int)nb_namespaces 
        namespaces:(const xmlChar**)namespaces 
        nb_attributes:(int)nb_attributes 
        nb_defaulted:(int)nb_defaulted 
        attributes:(const xmlChar**)attributes;
{
    // localnameを表示する
    printf("localname %s\n", localname);
	//	divタグにぶつかったなら、新しい項目を用意する。
    if (strncmp((char*)localname, "div", sizeof("div")) == 0) {
        bbsItem = [NSMutableDictionary dictionary];	//	空の辞書作成
        [bbs addObject:bbsItem];
		return;
	}
	//	b, font, blockquoteタグにぶつかったなら新しい文字列バッファを用意する。
	if (strncmp((char*)localname, "b", sizeof("b")) == 0
	|| strncmp((char*)localname, "font", sizeof("font")) == 0
	|| strncmp((char*)localname, "blockquote", sizeof("blockquote")) == 0) {
        // 文字列のためのバッファを作成する
        [curtstring release];
		curtstring = [[NSMutableString string] retain];
	}
}

/*
	startElementLocalNameで見つかったタグが閉じた時に呼び出される。
*/
- (void)endElementLocalName:(const xmlChar*)localname //	HTMLのタグが<>を外された形で入っている。例）</form> → form
        prefix:(const xmlChar*)prefix URI:(const xmlChar*)URI;
{
	//	b, font, blockquoteタグが閉じたなら、それまでに収集した文字列をそのタグのデータ文字列として登録。
	int type = keyword_Unknown;
	if (strncmp((char*)localname, "blockquote", sizeof("blockquote")) == 0)
		type = keyword_Comment;
	else if (strncmp((char*)localname, "font", sizeof("font")) == 0)
		type = keyword_Date;
	else if (strncmp((char*)localname, "b", sizeof("b")) == 0)
		type = keyword_Name;
	if (type != keyword_Unknown) {
        // 文字列を設定する
        [bbsItem setObject:curtstring forKey:keywords[type]];
        [curtstring release];
		curtstring = nil;
    }
}

/*
	現在のタグの文字列データが見つかった。
*/
- (void)charactersFound:(const xmlChar*)ch 
        len:(int)len;
{
    // 文字列を追加する
    if (curtstring) {
        NSString* string = [[NSString alloc] initWithBytes:ch length:len encoding:NSUTF8StringEncoding];
        [curtstring appendString:string];
        [string release];
    }
}
@end

